Subject: Re: [NET]: gen_estimator deadlock fix

From: Patrick McHardy <[email-masked]>
Date: Thu, 12 Jul 2007 14:07:12 +0200

[Removed Andrew from CC]

Ranko Zivojnovic wrote:
> I agree - it does look like the most sensible thing to do - have
> gnet_stats_basic and gnet_stats_rate_est allocated within the
> gen_estimator struct rather than pointers looking here and there - and
> provide api to maintain those stats - it simplifies the picture.

The API is not very pretty, some improvement there would be welcome.

> Also - the stats_lock in this case could be local to gen_estimator
> struct, thus making the implementation completely "dev agnostic" - and
> will not break on dev removal.

The queue lock is used since thats what protects the qdisc counters.